unit WWipeImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
TWISWipeStyle = (wisUp,wisDown,wisRight,wisLeft,wisCenter,wisCenterHoriz,wisCenterVert,
                 wisRightDown,wisRightUp,wisLeftDown,wisLeftUp,
                 wisCurtainVert,wisCurtainHoriz,wisFourCorners);

  TWWipeImage = class(TImage)
  private
  fWipePic:TBitmap;
  fWipeStyle:TWISWipeStyle;
  fWait:Integer;
  fExpand:Boolean;
    { Private declarations }
  protected
    { Protected declarations }
    Procedure SetBitmap(Value: TBitmap);
  public
    { Public declarations }

    constructor Create(AOwner: TComponent); override;
   destructor  Destroy; override;
  published
    { Published declarations }
    Procedure DoWipe;
    //--------------------
    Procedure DoLeftWipe;
    Procedure DoRightWipe;
    Procedure DoCenterHorizWipe;
    Procedure DoDownWipe;
    Procedure DoUpWipe;
    Procedure DoCenterVertWipe;
    Procedure DoCenterWipe;
    Procedure DoRightDownWipe;
    Procedure DoLeftDownWipe;
    Procedure DoRightUpWipe;
    Procedure DoLeftUpWipe;
    Procedure DoCurtainVertWipe;
    Procedure DoCurtainHorizWipe;
    Procedure DoFourCornersWipe;
    Procedure DoDemo;

//------------------------------------------------------------------------------
    Property WipePicture:TBitmap read fWipePic write SetBitmap;
    Property WipeStyle:TWISWipeStyle read fWipeStyle write fWipeStyle;
    Property WaitInterval:Integer read fWait write fWait;
    Property Expand:Boolean read fExpand write fExpand;

  end;

procedure Register;

implementation
//------------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('WAISS', [TWWipeImage]);
end;
//------------------------------------------------------------------------------
constructor TWWipeImage.Create(AOwner: TComponent);
begin

inherited Create(AOwner);
fWipePic := TBitmap.create();
height := 100;
width := 100;
fWait := 100;
//benabled := true;
end;
//------------------------------------------------------------------------------
destructor TWWipeImage.Destroy;
begin
fWipePic.Free;
inherited destroy;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.SetBitmap(Value: TBitmap);
Begin
  FWipePic.Assign(Value);
End;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoWipe;
begin
case fWipeStyle of
  wisLeft          : DoLeftWipe;
  wisRight         : DoRightWipe;
  wisCenterHoriz   : DoCenterHorizWipe;
  wisUp            : DoUpWipe;
  wisDown          : DoDownWipe;
  wisCenterVert    : DoCenterVertWipe;
  wisCenter        : DoCenterWipe;
  wisRightDown     : DoRightDownWipe;
  wisLeftDown      : DoLeftDownWipe;
  wisRightUp       : DoRightUpWipe;
  wisLeftUp        : DoLeftUpWipe;
  wisCurtainHoriz  : DoCurtainHorizWipe;
  wisCurtainVert   : DoCurtainVertWipe;
  wisFourCorners   : DoFourCornersWipe;
end;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoLeftWipe;
var i,w,tx,ty:integer;
begin
ty := height;
tx := width;
with canvas do
  for i := 1 to tx do
  begin
  FOR W := 1 to waitinterval do;
  if expand = false  then
  cOPYRECT(rect(0,0,i,ty),WipePicture.canvas,rect(0,0,i,ty))
  else
  cOPYRECT(rect(0,0,i,ty),WipePicture.canvas,rect(0,0,Width,height));
  application.ProcessMessages;
  end;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoRightWipe;
var i,w,tx,ty:integer;
begin
ty := height;
tx := width;
with canvas do
  for i := width downto 0 do
  begin
  FOR W := 1 to waitinterval do;
  //showmessage(inttostr(i));
  if expand = false  then
  cOPYRECT(rect(i,0,width,ty),WipePicture.canvas,rect(i,0,width,ty))
  else
  cOPYRECT(rect(i,0,width,ty),WipePicture.canvas,rect(0,0,Width,height));
  application.ProcessMessages;
  end;
end;
//------------------------------------------------------------------------------
procedure TWWipeImage.DoCenterHorizWipe;
var i,w,tx,ty:integer;
r:Trect;
s:single;
begin
ty := height div 2;
tx := width  div 2;
s:= height-width;
  for i := 1 to (tx ) do
  begin
  FOR W := 1 to WaitInterval do;
  r := rect(tx-i,0,tx+i,ty*2);
  //r:= rect((tx -i),(ty-i*round(s)),tx+i,ty+i*round(s));
  if expand then
canvas.cOPYRECT(r,wipepicture.canvas,rect(0,0,WipePicture.width,WipePicture.height))
  else
canvas.cOPYRECT(r,wipepicture.canvas,r);

  application.ProcessMessages;
end;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoDownWipe;
var i,w,tx,ty:integer;
begin
ty := height;
tx := width;
with canvas do
  for i := 1 to ty do
  begin
  FOR W := 1 to waitinterval do;
  if expand = false  then
  cOPYRECT(rect(0,0,tx,i),WipePicture.canvas,rect(0,0,tx,i) )
  else
  cOPYRECT(rect(0,0,tx,i),WipePicture.canvas,rect(0,0,Width,height));
  application.ProcessMessages;
  end;

end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoUpWipe;
var i,w,tx,ty:integer;
begin
ty := height;
tx := width;
with canvas do
  for i := ty downto 0 do
  begin
  FOR W := 1 to waitinterval do;
  if expand = false  then
  cOPYRECT(rect(0,ty,tx,i),WipePicture.canvas,rect(0,ty,tx,i) )
  else
  cOPYRECT(rect(0,i,tx,ty),WipePicture.canvas,rect(0,0,Width,height));
  application.ProcessMessages;
  end;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoCenterVertWipe;

var i,w,tx,ty:integer;
r:Trect;
s:single;
begin
ty := height div 2;
tx := width  div 2;
s:= height-width;
  for i := 1 to (ty ) do
  begin
  FOR W := 1 to WaitInterval do;
  r := rect(0,ty-i,tx*2,ty+i);
  //r:= rect((tx -i),(ty-i*round(s)),tx+i,ty+i*round(s));
  if expand then
canvas.cOPYRECT(r,wipepicture.canvas,rect(0,0,WipePicture.width,WipePicture.height))
  else
canvas.cOPYRECT(r,wipepicture.canvas,r);

  application.ProcessMessages;
end;
end;
//------------------------------------------------------------------------------
procedure TWWipeImage.DoCenterWipe;
var i,w,tx,ty:integer;
r:Trect;
s:single;
begin
ty := height div 2;
tx := width  div 2;
s:= height / width;
  for i := 1 to (tx ) do
  begin
  FOR W := 1 to WaitInterval do;
 // r := rect(tx-i,0,tx+i,ty*2);
  r:= rect((tx -i),round(ty-i*s),tx+i,round(ty+i*s));
  if expand then
canvas.cOPYRECT(r,wipepicture.canvas,rect(0,0,WipePicture.width,WipePicture.height))
  else
canvas.cOPYRECT(r,wipepicture.canvas,r);

  application.ProcessMessages;
end;
end;
//------------------------------------------------------------------------------
procedure TWWipeImage.DoRightDownWipe;
var i,w,tx,ty:integer;
r:Trect;
s:single;
begin
ty := height ;
tx := width  ;
s:= height / width;
  for i := 1 to (tx ) do
  begin
  FOR W := 1 to WaitInterval do;
 // r := rect(tx-i,0,tx+i,ty*2);
  r:= rect(0,0,i,round(i*s));
  if expand then
canvas.cOPYRECT(r,wipepicture.canvas,rect(0,0,WipePicture.width,WipePicture.height))
  else
canvas.cOPYRECT(r,wipepicture.canvas,r);

  application.ProcessMessages;
end;
end;
//------------------------------------------------------------------------------
procedure TWWipeImage.DoLeftDownWipe;
var i,w,tx,ty:integer;
r:Trect;
s:single;
begin
ty := height;
tx := width;
s:= height / width;
  for i := 0 to tx do
  begin
  FOR W := 1 to WaitInterval do;
 // r := rect(tx-i,0,tx+i,ty*2);
  r:= rect((tx -i),0,tx,round(i*s));
  if expand then
canvas.cOPYRECT(r,wipepicture.canvas,rect(0,0,WipePicture.width,WipePicture.height))
  else
canvas.cOPYRECT(r,wipepicture.canvas,r);

  application.ProcessMessages;
end;
end;
//------------------------------------------------------------------------------
procedure TWWipeImage.DoLeftUpWipe;
var i,w,tx,ty:integer;
r:Trect;
s:single;
begin
ty := height;
tx := width;
s:= height / width;
  for i := 1 to (tx ) do
  begin
  FOR W := 1 to WaitInterval do;
 // r := rect(tx-i,0,tx+i,ty*2);
  r:= rect(tx-i,round(ty-i*s),tx,ty);
  if expand then
canvas.cOPYRECT(r,wipepicture.canvas,rect(0,0,WipePicture.width,WipePicture.height))
  else
canvas.cOPYRECT(r,wipepicture.canvas,r);

  application.ProcessMessages;
end;
end;
//------------------------------------------------------------------------------
procedure TWWipeImage.DoRightUpWipe;
var i,w,tx,ty:integer;
r:Trect;
s:single;
begin
ty := height;
tx := width;
s:= height / width;
  for i := 1 to (tx ) do
  begin
  FOR W := 1 to WaitInterval do;
 // r := rect(tx-i,0,tx+i,ty*2);
  r:= rect(0,round(ty-i*s),i,ty);
  if expand then
canvas.cOPYRECT(r,wipepicture.canvas,rect(0,0,WipePicture.width,WipePicture.height))
  else
canvas.cOPYRECT(r,wipepicture.canvas,r);

  application.ProcessMessages;
end;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoCurtainHorizWipe;
var i,w,tx,ty:integer;
begin
ty := height div 2;
tx := width div 2;
with canvas do
  for i := 0 to tx do
  begin
  FOR W := 1 to waitinterval do;
  //showmessage(inttostr(i));
  if expand = false  then
  begin
  cOPYRECT(rect(0,0,i,ty * 2),WipePicture.canvas,rect(0,0,i,ty * 2));
  cOPYRECT(rect(tx*2-i,0,tx*2,ty * 2),WipePicture.canvas,rect(tx*2-i,0,tx*2,ty * 2));
  end
  else
  begin
  cOPYRECT(rect(0,0,i,ty * 2),WipePicture.canvas,rect(0,0,Width div 2,height));
  cOPYRECT(rect(tx*2-i,0,tx*2,ty * 2),WipePicture.canvas,rect(Width div 2,0,width,height));
  end;
  application.ProcessMessages;
  end;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoCurtainVertWipe;
var i,w,tx,ty:integer;
begin
ty := height div 2;
tx := width ;
with canvas do
  for i := 0 to ty do
  begin
  FOR W := 1 to waitinterval do;
  //showmessage(inttostr(i));
  if expand = false  then
  begin
  cOPYRECT(rect(0,0,tx,i),WipePicture.canvas,rect(0,0,tx,i));
  cOPYRECT(rect(0,height-i,tx,ty*2),WipePicture.canvas,rect(0,height-i,tx,ty*2));
  end
  else
  begin
  cOPYRECT(rect(0,0,tx,i),WipePicture.canvas,rect(0,0,Width ,height div 2));
  cOPYRECT(rect(0,height-i,tx,ty*2),WipePicture.canvas,rect(0 ,height div 2,width,height));
  end;
  application.ProcessMessages;
  end;
end;
//------------------------------------------------------------------------------
Procedure TWWipeImage.DoFourCornersWipe;
var i,w,tx,ty:integer;
s: Single;
begin
ty := height ;
tx := width;
s:= height / width;
with canvas do
  for i := 0 to tx div 2 do
  begin
  FOR W := 1 to waitinterval do;
  //showmessage(inttostr(i));
  if expand = false  then
  begin
  cOPYRECT(rect(0,0,i,round(s*i)),WipePicture.canvas,rect(0,0,i,round(s*i)));
  cOPYRECT(rect(0,ty - round(i*s) ,i,round(ty)),WipePicture.canvas,rect(0,ty - round(i*s) ,i,round(ty)));
  cOPYRECT(rect(tx - i,0,tx,round(s*i)),WipePicture.canvas,rect(tx - i,0,tx,round(s*i)));
  cOPYRECT(rect(tx-i,ty - round(i*s),tx,ty),WipePicture.canvas,rect(tx-i,ty - round(i*s),tx,ty));
  end
  else
  begin
  cOPYRECT(rect(0,0,i,round(s*i)),WipePicture.canvas,rect(0,0,tx div 2,ty div 2));
  cOPYRECT(rect(0,ty - round(i*s) ,i,round(ty)),WipePicture.canvas,rect(0,ty div 2,tx div 2,ty));
  cOPYRECT(rect(tx - i,0,tx,round(s*i)),WipePicture.canvas,rect(tx div 2,0,tx,ty div 2));
  cOPYRECT(rect(tx-i,ty - round(i*s),tx,ty),WipePicture.canvas,rect(tx div 2,ty div 2,tx,ty))
  end;
  application.ProcessMessages;
  end;
end;
//------------------------------------------------------------------------------
procedure TWWipeImage.DoDemo;
begin
DoLeftWipe;
     DoRightWipe;
    DoCenterHorizWipe;
     DoDownWipe;
     DoUpWipe;
     DoCenterVertWipe;
     DoCenterWipe;
     DoRightDownWipe;
     DoLeftDownWipe;
     DoRightUpWipe;
     DoLeftUpWipe;
     DoCurtainVertWipe;
     DoCurtainHorizWipe;
     DoFourCornersWipe;
     end;
end.
